/**
/// HashTag.Core Library
/// Copyright © 2010-2013
///
/// This module is Copyright © 2010-2013 Steve Powell
/// All rights reserved.
///
/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the Microsoft Public License (Ms-PL)
/// 
/// This library is distributed in the hope that it will be
/// useful, but WITHOUT ANY WARRANTY; without even the implied
/// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
/// PURPOSE.  See theMicrosoft Public License (Ms-PL) License for more
/// details.
///
/// You should have received a copy of the Microsoft Public License (Ms-PL)
/// License along with this library; if not you may 
/// find it here: http://www.opensource.org/licenses/ms-pl.html
///
/// Steve Powell, hashtagdonet@gmail.com
**/
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
namespace ScrimpNet.Collections.Generic
{
	[Serializable()]
	[CollectionDataContract]
	[Citation("http://ianfnelson.com/archives/2006/09/17/a-serializeable-keyvaluepair-class/")]
	public class PropertyBag<TKey, TValue> :
	Collection<Property<TKey, TValue>>,ICloneable
	{
		public PropertyBag():base()
		{
			//for serialization purposes only
		}
		public void Add(TKey key, TValue value)
		{
			this.Add(new Property<TKey,
			TValue>(key, value));
		}

		public object Clone()
		{
			var newBag = new PropertyBag<TKey, TValue>();
			foreach (var prop in this)
			{
				newBag.Add((Property<TKey,TValue>)prop.Clone());
			}
			return newBag;
		}
	}
}