/**
/// HashTag.Core Library
/// Copyright © 2010-2013
///
/// This module is Copyright © 2010-2013 Steve Powell
/// All rights reserved.
///
/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the Microsoft Public License (Ms-PL)
/// 
/// This library is distributed in the hope that it will be
/// useful, but WITHOUT ANY WARRANTY; without even the implied
/// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
/// PURPOSE.  See theMicrosoft Public License (Ms-PL) License for more
/// details.
///
/// You should have received a copy of the Microsoft Public License (Ms-PL)
/// License along with this library; if not you may 
/// find it here: http://www.opensource.org/licenses/ms-pl.html
///
/// Steve Powell, hashtagdonet@gmail.com
**/
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
namespace ScrimpNet.Collections.Generic
{
	[Serializable()]
	[Citation("http://ianfnelson.com/archives/2006/09/17/a-serializeable-keyvaluepair-class/")]
	public class SerializedDictionary<TKey, TValue> :
	KeyedCollection<TKey, Property
	<TKey, TValue>>
	{
		protected override TKey GetKeyForItem(
		Property<TKey, TValue> item)
		{
			return item.Key;
		}
		public void Add(TKey key, TValue value)
		{
			this.Add(new Property<TKey,
			TValue>(key, value));
		}
	}
}