/**
/// HashTag.Core Library
/// Copyright © 2010-2013
///
/// This module is Copyright © 2010-2013 Steve Powell
/// All rights reserved.
///
/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the Microsoft Public License (Ms-PL)
/// 
/// This library is distributed in the hope that it will be
/// useful, but WITHOUT ANY WARRANTY; without even the implied
/// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
/// PURPOSE.  See theMicrosoft Public License (Ms-PL) License for more
/// details.
///
/// You should have received a copy of the Microsoft Public License (Ms-PL)
/// License along with this library; if not you may 
/// find it here: http://www.opensource.org/licenses/ms-pl.html
///
/// Steve Powell, hashtagdonet@gmail.com
**/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.Collections;
using System.Runtime.Serialization;
using System.Xml.Serialization;
using System.Security.Cryptography;

namespace HashTag.Cryptography
{
    public partial class Crypto
    {
        public class SegmentNames
        {
            public const string PublicKeyOnly = "HashTag.com/cryptography/segment/publicKeyOnly";
            public const string PublicPrivateKey = "HashTag.com/cryptography/segment/publicPrivateKey";
            public const string SymmetricKey = "HashTag.com/cryptography/segment/key";
            public const string SymmetricIv = "HashTag.com/cryptography/segment/initializationVector";
            public const string HashSalt = "HashTag.com/cryptography/segment/hashSalt";
        }

        public class PropertyValueTypes
        {
            public const string String = "HashTag.com/cryptography/propertyValue/string";
            public const string DateTime = "HashTag.com/cryptography/propertyValue/datetime";
            public const string UniqueIdentifier = "HashTag.com/cryptography/propertyValue/uniqueIdentifier";
            public const string Boolean = "HashTag.com/cryptography/propertyValue/boolean";
            public const string Number = "HashTag.com/cryptography/propertyValue/number";
            public const string Object = "HashTag.com/cryptography/propertyValue/base64";
        }

        public class PropertyNames
        {
            public const string HashSaltedMode = "HashTag.com/cryptography/property/saltedHashMode";
            public const string HashSimpleMode = "HashTag.com/cryptography/property/simpleHashMode";
            public const string EncodeMode = "HashTag.com/cryptography/property/encodeMode";
        }

        public class EncodeModes
        {
            public const string AES = "HashTag.com/cryptography/mode/aes";
            public const string DES = "HashTag.com/cryptography/mode/des";            
            public const string RC2 = "HashTag.com/cryptography/mode/rc2";
            public const string Rijindael = "HashTag.com/cryptography/mode/rijindael";
            public const string RSA = "HashTag.com/cryptography/mode/rsa";
            public const string TripleDES = "HashTag.com/cryptography/mode/tripleDES";
        }

        public class HashModesSimple
        {
            public const string MD5 = "HashTag.com/cryptography/hash/MD5";
            public const string SHA1 = "HashTag.com/cryptography/hash/SHA1";
            public const string SHA256 = "HashTag.com/cryptography/hash/SHA256";
            public const string SHA384 = "HashTag.com/cryptography/hash/SHA384";
            public const string SHA512 = "HashTag.com/cryptography/hash/SHA512";
            public const string RIPEMD160 = "HashTag.com/cryptography/hash/RIPEMD160";   
        }

        public class HashModesSalted
        {
            public const string HMACSHA1 = "HashTag.com/cryptography/hashkeyed/HMACSHA1";
            public const string HMACSHA256 = "HashTag.com/cryptography/hashkeyed/HMACSHA256";
            public const string HMACSHA384 = "HashTag.com/cryptography/hashkeyed/HMACSHA384";
            public const string HMACSHA512 = "HashTag.com/cryptography/hashkeyed/HMACSHA512";
            public const string HMACMD5 = "HashTag.com/cryptography/hashkeyed/HMACMD5";
            public const string HMACRIPEMD160 = "HashTag.com/cryptography/hashkeyed/HMACRIPEMD160";
            public const string MACTrippleDES = "HashTag.com/cryptography/hashkeyed/MACTripleDES";
        }
    }
}