/**
/// HashTag.Core Library
/// Copyright © 2010-2013
///
/// This module is Copyright © 2010-2013 Steve Powell
/// All rights reserved.
///
/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the Microsoft Public License (Ms-PL)
/// 
/// This library is distributed in the hope that it will be
/// useful, but WITHOUT ANY WARRANTY; without even the implied
/// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
/// PURPOSE.  See theMicrosoft Public License (Ms-PL) License for more
/// details.
///
/// You should have received a copy of the Microsoft Public License (Ms-PL)
/// License along with this library; if not you may 
/// find it here: http://www.opensource.org/licenses/ms-pl.html
///
/// Steve Powell, hashtagdonet@gmail.com
**/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HashTag.Diagnostics
{
    /// <summary>
    /// Determines data to be retrieved by HTTPContextCollector
    /// </summary>
    [Flags]
    public enum HttpCaptureFlags
    {
        /// <summary>
        /// 0 - no http context will be captured
        /// </summary>
        None = 0,

        /// <summary>
        /// Return Method and full URL GET http://mysite.com/admin.aspx?q1=12
        /// </summary>
        Url = 1,

        /// <summary>
        /// Return all form fields and their values
        /// </summary>
        Form = 2,

        /// <summary>
        /// Return all session keys and the ToString() of their values
        /// </summary>
        Session = 3,

        /// <summary>
        /// Return all application keys and the ToString() of their values
        /// </summary>
        AppCache = 4,

        /// <summary>
        /// Return all above values of HttpContext
        /// </summary>
        All = Url | Form | Session | AppCache

    }
}