/**
/// HashTag.Core Library
/// Copyright © 2010-2013
///
/// This module is Copyright © 2010-2013 Steve Powell
/// All rights reserved.
///
/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the Microsoft Public License (Ms-PL)
/// 
/// This library is distributed in the hope that it will be
/// useful, but WITHOUT ANY WARRANTY; without even the implied
/// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
/// PURPOSE.  See theMicrosoft Public License (Ms-PL) License for more
/// details.
///
/// You should have received a copy of the Microsoft Public License (Ms-PL)
/// License along with this library; if not you may 
/// find it here: http://www.opensource.org/licenses/ms-pl.html
///
/// Steve Powell, hashtagdonet@gmail.com
**/
using System;
namespace HashTag.Diagnostics

{
	public interface ILog
	{
		
		void Dispose();
		void Dispose(bool isDisposing);
        
		bool IsLevelEnabled(HashTag.Diagnostics.MessageLevel level);
		HashTag.Diagnostics.LoggerLevels LogLevels { get; set; }

		event HashTag.Diagnostics.Log.LogWrite OnLogCriticalEventHandler;
        event HashTag.Diagnostics.Log.LogWrite OnLogDebugEventHandler;
        event HashTag.Diagnostics.Log.LogWrite OnLogErrorEventHandler;
        event HashTag.Diagnostics.Log.LogWrite OnLogInformationEventHandler;
        event HashTag.Diagnostics.Log.LogWrite OnLogWarningEventHandler;
		HashTag.Diagnostics.LoggerLevels SetLogLevel(HashTag.Diagnostics.LoggerLevels logLevel, bool value);
		
        
		void Write(HashTag.Diagnostics.LogMessage message);
		void Write(object message);
	}
}