/**
/// HashTag.Core Library
/// Copyright © 2010-2013
///
/// This module is Copyright © 2010-2013 Steve Powell
/// All rights reserved.
///
/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the Microsoft Public License (Ms-PL)
/// 
/// This library is distributed in the hope that it will be
/// useful, but WITHOUT ANY WARRANTY; without even the implied
/// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
/// PURPOSE.  See theMicrosoft Public License (Ms-PL) License for more
/// details.
///
/// You should have received a copy of the Microsoft Public License (Ms-PL)
/// License along with this library; if not you may 
/// find it here: http://www.opensource.org/licenses/ms-pl.html
///
/// Steve Powell, hashtagdonet@gmail.com
**/
using System;
using System.Collections.Generic;
using System.Text;

namespace HashTag.Diagnostics
{
	public partial class Log : ILog
	{
        /// <summary>
        /// Write a message to log using message's internal LogLevel status
        /// </summary>
        /// <param name="message">message to write</param>
        public delegate void LogWrite(LogMessage message);

        /// <summary>
        /// Fired when provider wants to write a debug message
        /// </summary>
        public event LogWrite OnLogDebugEventHandler;

        /// <summary>
        /// Fired when a provider wants to write a warning message
        /// </summary>
        public event LogWrite OnLogWarningEventHandler;

        /// <summary>
        /// Fired when a provider wants to write an info message
        /// </summary>
        public event LogWrite OnLogInformationEventHandler;

        /// <summary>
        /// Fired when a provider wants to write an error message
        /// </summary>
        public event LogWrite OnLogErrorEventHandler;

        /// <summary>
        /// Fired when a provider wants to write a Critial message
        /// </summary>
        public event LogWrite OnLogCriticalEventHandler;

        /// <summary>
        /// Fired when a provider wants to write a Start operation message
        /// </summary>
        public event LogWrite OnLogStartEventHandler;

        /// <summary>
        /// Fired when a provider wants to write a Stop operation message
        /// </summary>
        public event LogWrite OnLogStopEventHandler;

   	}
}