/**
/// HashTag.Core Library
/// Copyright © 2010-2013
///
/// This module is Copyright © 2010-2013 Steve Powell
/// All rights reserved.
///
/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the Microsoft Public License (Ms-PL)
/// 
/// This library is distributed in the hope that it will be
/// useful, but WITHOUT ANY WARRANTY; without even the implied
/// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
/// PURPOSE.  See theMicrosoft Public License (Ms-PL) License for more
/// details.
///
/// You should have received a copy of the Microsoft Public License (Ms-PL)
/// License along with this library; if not you may 
/// find it here: http://www.opensource.org/licenses/ms-pl.html
///
/// Steve Powell, hashtagdonet@gmail.com
**/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HashTag.Serialization.TNet
{
    /// <summary>
    /// Convenience class containing TNet field delimiters
    /// </summary>
	public class TNetDelimiter
	{
        /// <summary>
        /// '+'
        /// </summary>
        public const char Guid = '+';

		/// <summary>
		/// ,
		/// </summary>
		public const char String = ',';
		/// <summary>
		/// #
		/// </summary>
		public const char Integer = '#';

        /// <summary>
        /// '^'
        /// </summary>
		public const char Float = '^';

        /// <summary>
        /// '!'
        /// </summary>
		public const char Boolean = '!';

        /// <summary>
        /// '}'
        /// </summary>
		public const char Dictionary = '}';

        /// <summary>
        /// ']'
        /// </summary>
		public const char List = ']';

        /// <summary>
        /// '*'
        /// </summary>
		public const char Binary = '*';

        /// <summary>
        /// '@'
        /// </summary>
		public const char DateTime = '@';

        /// <summary>
        /// '~'
        /// </summary>
		public const char Null = '~';
	}


}